#ifndef __RT__SCHED__
#define __RT__SCHED__

#include <asm/rt_time.h>
#define RT_TASK_MAGIC 0x754d2774

#define RT_LOWEST_PRIORITY	1000000
#define RT_BIGGEST_PERIOD	1000000
enum {RT_TASK_READY, RT_TASK_DELAYED, RT_TASK_DORMANT};

struct rt_task_struct {
	int *stack; 	/* hardcoded */
	int uses_fp;	/* this one is too   */
	int magic;
	int state;
	int *stack_bottom;
	int priority;
        int identifier;			/* Monotonic */
	RTIME comp_time;		/* Monotonic */
	RTIME period;
	RTIME resume_time;
	struct rt_task_struct *next;
};

typedef struct rt_task_struct RT_TASK;

extern RT_TASK *rt_current;

extern int rt_task_init(RT_TASK *task, void (*fn)(int data), int data, 
			int stack_size, int id); /* Monotonic */

extern int rt_task_delete(RT_TASK *task);
extern int rt_task_wait(void);

extern int rt_task_suspend(RT_TASK *task);
extern int rt_task_wakeup(RT_TASK *task);

extern int rt_task_make_periodic(RT_TASK *task, RTIME start_time, 
				 RTIME period); /* Monotonic */

extern inline void rt_use_fp(int flag)
{
	rt_current->uses_fp = flag;
}

#endif
